summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Steven Voges <svoges.sbo@gmail.com>2022-08-25 20:22:54 +0100
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2022-08-27 22:50:30 +0700
commit1f74bbee507eb8a49897be65932f809a5de62102 (patch)
tree17ad3b9d7a7e9126f6a079d30f779fc854c65081
parentf5c3cb169f5fc396b56cf7f3464bef2d17bc6254 (diff)
downloadslackbuilds-1f74bbee507eb8a49897be65932f809a5de62102.tar.gz
slackbuilds-1f74bbee507eb8a49897be65932f809a5de62102.tar.xz
libraries/qt6: Added (Application Development Framework)
Signed-off-by: Dave Woodfall <dave@slackbuilds.org> Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--libraries/qt6/README33
-rw-r--r--libraries/qt6/README.SLACKWARE34
-rw-r--r--libraries/qt6/qt6.SlackBuild145
-rw-r--r--libraries/qt6/qt6.info12
-rw-r--r--libraries/qt6/slack-desc19
5 files changed, 243 insertions, 0 deletions
diff --git a/libraries/qt6/README b/libraries/qt6/README
new file mode 100644
index 0000000000..d235fa378c
--- /dev/null
+++ b/libraries/qt6/README
@@ -0,0 +1,33 @@
+Qt is a cross-platform application development framework for desktop,
+embedded and mobile. Supported Platforms include Linux, OS X,
+Windows, VxWorks, QNX, Android, iOS, BlackBerry, Sailfish OS and
+others.
+
+Qt is not a programming language on its own. It is a framework written
+in C++. A preprocessor, the MOC (Meta-Object Compiler), is used to
+extend the C++ language with features like signals and slots. Before
+the compilation step, the MOC parses the source files written in
+Qt-extended C++ and generates standard compliant C++ sources from
+them. Thus the framework itself and applications/libraries using it
+can be compiled by any standard compliant C++ compiler like Clang,
+GCC, ICC, MinGW and MSVC.
+
+Qt6 has a compiler cache option when building. By default, this
+behavior is disabled. To enable it, pass CCACHE=ON to the build script.
+Unless you are building qt6 multiple times, you should leave this
+option OFF.
+
+Examples are disabled by default. To build them, pass EXAMPLES=ON
+to the build script.
+
+When building Qt's webengine, proprietary codecs are disabled by
+default. To enable them, pass PROPRIETARY_CODECS=ON to the build
+script. This will make the resulting package non-redistributable.
+
+Qt6 requires 16GB of RAM to build, and a minimum of 40GB of available
+disk storage. Disk storage requirements may increase when built
+against optional dependencies.
+
+Qt6 will autodetect and build against multiple external programs and
+libraries. To see a list of optional dependencies, please consult
+README.SLACKWARE
diff --git a/libraries/qt6/README.SLACKWARE b/libraries/qt6/README.SLACKWARE
new file mode 100644
index 0000000000..675c6c1577
--- /dev/null
+++ b/libraries/qt6/README.SLACKWARE
@@ -0,0 +1,34 @@
+Slackware 15.0's version of clang fails to compile qt6, due to the
+following error:
+
+Linking CXX executable ../../../../qtbase/bin/lupdate
+/usr/bin/ld: CMakeFiles/lupdate.dir/cpp_clang.cpp.o: undefined
+ reference to symbol '_ZTIN5clang7tooling21FrontendActionFactoryE'
+/usr/bin/ld: /usr/lib64/libclangTooling.so.13: error adding symbols:
+ DSO missing from command line
+collect2: error: ld returned 1 exit status
+
+To remedy this, Qt provides a prebuilt clang package that we bootstrap
+against.
+
+Qt6 will compile with multiple optional dependencies, such as:
+
+ assimp
+ (*)db2
+ (*)cerence
+ (*)directfb
+ (*)gn
+ (*)interbase
+ (*)litehtml
+ (*)lttn-ust
+ mold
+ postgresql
+ (*)sensorfw
+ (*)s-log2
+ snappy
+ (*)tslib
+ xmlstarlet
+
+ ...and possibly others.
+
+(*) = not available from SBo at the time of writing.
diff --git a/libraries/qt6/qt6.SlackBuild b/libraries/qt6/qt6.SlackBuild
new file mode 100644
index 0000000000..e11d853714
--- /dev/null
+++ b/libraries/qt6/qt6.SlackBuild
@@ -0,0 +1,145 @@
+#!/bin/bash
+
+# Slackware build script for qt6
+
+# Copyright 2022 Steven Voges <svoges.sbo@gmail.com>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=qt6
+SRCNAM=qt-everywhere-src
+VERSION=${VERSION:-6.3.1}
+BSCLANG=libclang-release_130-based-linux-Ubuntu20.04-gcc9.3-x86_64
+CCACHE=${CCACHE:-OFF}
+EXAMPLES=${EXAMPLES:-OFF}
+LINKED_OPENSSL=${LINKED_OPENSSL:-ON}
+PROPRIETARY_CODECS=${PROPRIETARY_CODECS:-OFF}
+SYSTEM_FFMPEG=${SYSTEM_FFMPEG:-ON}
+SYSTEM_SQLITE=${SYSTEM_SQLITE:-ON}
+SYSTEM_XCB_INPUT=${SYSTEM_XCB_INPUT:-ON}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $SRCNAM-$VERSION
+tar xvf $CWD/$SRCNAM-$VERSION.tar.xz
+cd $SRCNAM-$VERSION
+7z x $CWD/$BSCLANG.7z
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p build
+cd build
+ cmake \
+ -G Ninja \
+ -Wno-dev \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DClang_DIR=$TMP/$SRCNAM-$VERSION/libclang/lib/cmake/clang \
+ -DFEATURE_openssl_linked=$LINKED_OPENSSL \
+ -DFEATURE_system_sqlite=$SYSTEM_SQLITE \
+ -DFEATURE_system_xcb_xinput=$SYSTEM_XCB_INPUT \
+ -DFEATURE_webengine_proprietary_codecs=$PROPRIETARY_CODECS \
+ -DFEATURE_webengine_system_ffmpeg=$SYSTEM_FFMPEG \
+ -DINSTALL_BINDIR=./lib${LIBDIRSUFFIX}/$PRGNAM/bin \
+ -DINSTALL_DESCRIPTIONSDIR=./lib${LIBDIRSUFFIX}/$PRGNAM/modules \
+ -DINSTALL_DOCDIR=./doc/$PRGNAM-$VERSION \
+ -DINSTALL_EXAMPLESDIR=./doc/$PRGNAM-$VERSION/examples \
+ -DINSTALL_INCLUDEDIR=./include/$PRGNAM \
+ -DINSTALL_LIBDIR=./lib${LIBDIRSUFFIX} \
+ -DINSTALL_LIBEXECDIR=./lib${LIBDIRSUFFIX}/$PRGNAM/libexec \
+ -DINSTALL_MKSPECSDIR=./lib${LIBDIRSUFFIX}/$PRGNAM/mkspecs \
+ -DINSTALL_PLUGINSDIR=./lib${LIBDIRSUFFIX}/$PRGNAM/plugins \
+ -DINSTALL_QMLDIR=./lib${LIBDIRSUFFIX}/$PRGNAM/qml \
+ -DINSTALL_TRANSLATIONSDIR=./share/$PRGNAM/translations \
+ -DINSTALL_TESTSDIR=./lib${LIBDIRSUFFIX}/$PRGNAM/tests \
+ -DQT_BUILD_EXAMPLES=$EXAMPLES \
+ -DQT_USE_CCACHE=$CCACHE \
+ -DCMAKE_BUILD_TYPE=Release ..
+ cmake --build . --parallel
+ DESTDIR=$PKG cmake --install . --strip
+cd ..
+
+mv $PKG/usr/phrasebooks $PKG/usr/share/$PRGNAM/
+mv $PKG/usr/resources $PKG/usr/share/$PRGNAM/
+
+if [ "$EXAMPLES" = "ON" ]; then
+ find -L $PKG/usr/doc/$PRGNAM-$VERSION/examples \
+ -type d -exec chmod 755 {} \;
+ find -L $PKG/usr/doc/$PRGNAM-$VERSION/examples \
+ -type f -exec chmod 644 {} \;
+fi
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ .QT-ENTERPRISE-LICENSE-AGREEMENT LICENSE.* README.md \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/libraries/qt6/qt6.info b/libraries/qt6/qt6.info
new file mode 100644
index 0000000000..c636331d3c
--- /dev/null
+++ b/libraries/qt6/qt6.info
@@ -0,0 +1,12 @@
+PRGNAM="qt6"
+VERSION="6.3.1"
+HOMEPAGE="https://qt.io"
+DOWNLOAD="https://download.qt.io/official_releases/qt/6.3/6.3.1/single/qt-everywhere-src-6.3.1.tar.xz \
+ https://download.qt.io/development_releases/prebuilt/libclang/libclang-release_130-based-linux-Ubuntu20.04-gcc9.3-x86_64.7z"
+MD5SUM="957a304773b281a4584f4c0254773456 \
+ 1eb94ba35df4aa217cf485086215182a"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="double-conversion html5lib md4c nodejs p7zip"
+MAINTAINER="Steven Voges"
+EMAIL="svoges.sbo@gmail.com"
diff --git a/libraries/qt6/slack-desc b/libraries/qt6/slack-desc
new file mode 100644
index 0000000000..32c3c86424
--- /dev/null
+++ b/libraries/qt6/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+qt6: qt6 (Application Development Framework)
+qt6:
+qt6: Qt is a cross-platform application development framework for desktop,
+qt6: embedded and mobile. Supported Platforms include Linux, OS X,
+qt6: Windows, VxWorks, QNX, Android, iOS, BlackBerry, Sailfish OS and
+qt6: others.
+qt6:
+qt6: Homepage: https://qt.io
+qt6:
+qt6:
+qt6: